//   Copyright 2012 Georg-August-Universität Göttingen, Germany
//
//   Licensed under the Apache License, Version 2.0 (the "License");
//   you may not use this file except in compliance with the License.
//   You may obtain a copy of the License at
//
//       http://www.apache.org/licenses/LICENSE-2.0
//
//   Unless required by applicable law or agreed to in writing, software
//   distributed under the License is distributed on an "AS IS" BASIS,
//   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//   See the License for the specific language governing permissions and
//   limitations under the License.

package de.ugoe.cs.autoquest.tasktrees.treeifc;

// TODO: Auto-generated Javadoc
/**
 * <p>
 * the instance of an {@link ISelection}. The instance has a child being an
 * instance of the child task of the selection that was selected for execution.
 * </p>
 * 
 * @author Patrick Harms
 */
public interface ISelectionInstance extends ITaskInstance {

	/**
	 * <p>
	 * clones this task instance by creating exact clones of the contained
	 * instance
	 * </p>.
	 *
	 * @return a clone of the task instance
	 */
	@Override
	public ISelectionInstance clone();

	/**
	 * <p>
	 * returns the selected child of the selection
	 * </p>.
	 *
	 * @return as described
	 */
	public ITaskInstance getChild();

	/**
	 * <p>
	 * returns the task related to the instance, i.e. the selection.
	 * </p>
	 * 
	 * @return as described
	 */
	public ISelection getSelection();

}
